VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Aknakeres"
   ClientHeight    =   5085
   ClientLeft      =   2430
   ClientTop       =   2385
   ClientWidth     =   6840
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5085
   ScaleWidth      =   6840
   Begin VB.CommandButton Button 
      Caption         =   "j Jtk"
      Height          =   375
      Index           =   0
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "10"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1920
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Aknk:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   238
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1080
      TabIndex        =   1
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Mezok(1 To 500) As MezoInfo
Private Generalva As Boolean
Private Leteve As Boolean
Private FirstOpen As Integer
Private Opened As Integer
Private Flagged As Integer
Private AknaSzam As Integer
Private Sorok As Integer
Private Oszlopok As Integer
Private F2 As Form2
Private PrevSize As Integer

'Gombkattints esemnykezel
'Az indexbl tudjuk melyik gomb lett lenyomva
Private Sub Button_Click(Index As Integer)
If Index = 0 Then  'j jtk gomb
UnloadButtons      'Korbbi mezket bezrjuk
Set F2 = New Form2
F2.show vbModal  'Mutatjuk a mretablakot s vrunk, mig az be nem zrdik
Sorok = F2.rows
Oszlopok = F2.cols
AknaSzam = F2.mines
PrevSize = Sorok * Oszlopok   'Elmentjk a mretet
    For i = 0 To Sorok - 1
        For j = 1 To Oszlopok
            InitButton i, j     'Lterehozzuk a gombokat
        Next j
    Next i
    Me.Width = Oszlopok * 300 + 600  'Dinamikus mretezs
    Me.Height = Sorok * 300 + 1300
    Opened = 0
    Flagged = 0
    Label2.Caption = AknaSzam
    Generalva = False   'Mg nem helyeztk el az aknkat
   ' End If
    
ElseIf Not Generalva Then       'Els kattintsunk jtkmezre
    FirstOpen = Index           'Amire kattintottunk ott nem lehet bomba
    GenerateMines               'Helyezzk el az aknkat
    OpenField Index, False      'Nyissuk ki a kattintott mezt
Else
    OpenField Index, False      'Egybknt nyissuk ki a mezt
End If
End Sub

'A korbban elhelyezett gombokat becsukjuk
Private Sub UnloadButtons()
For i = 1 To PrevSize
    Unload Button(i)
    Next i
End Sub


'Jobb kattints kezel
Private Sub Button_MouseUp(Index As Integer, Butt As Integer, Shift As Integer, x As Single, y As Single)
If Butt = 2 And Generalva Then 'Jobb katt s mr vannak letve bombk
    If Mezok(Index).Nyitott Then    'Ha mr nyitott mezre klikeltnk
        If CountAdjFlags(Index) = Mezok(Index).Szomszedos Then  's krltte annyivan megjellve, ahny bomba van mellette
        OpenNeighbours Index, False  'Nyissuk ki a jelletlen szomszdokat
        End If

   Else  'Olyan hely, amit mg nem nyitottunk ki
    FlagField (Index)  'Jelljk meg a helyet
   End If
End If
End Sub



'Gombok ltrehozsa s elhelyezse
Private Sub InitButton(ByVal i As Integer, ByVal j As Integer)
    Index = Oszlopok * i + j
    Load Button(Index)
    
    Button(Index).Height = 300
    Button(Index).Width = 300
    Button(Index).Left = 300 * j - 150
    Button(Index).Top = 550 + i * 300
    Button(Index).Caption = ""
    Button(Index).Visible = True
End Sub


'Mez megjells
Private Sub FlagField(Index As Integer)
If Generalva Then   'Csak akkor jellnk ha a bombk el vannak helyezve
    If Not Mezok(Index).Nyitott Then  'Ha nincs kinyitva  a hely
        Mezok(Index).Flagged = Not Mezok(Index).Flagged
        Button(Index).Caption = IIf(Mezok(Index).Flagged, "!", "")
        If Mezok(Index).Flagged Then
            Flagged = Flagged + 1
            Button(Index).BackColor = vbRed
        Else
            Flagged = Flagged - 1
            Button(Index).BackColor = &H8000000F
        End If
        Label2.Caption = AknaSzam - Flagged   ' Kevesebb akna van htra
    End If
    End If
End Sub


'Aknk elhelyezse
Private Sub GenerateMines()

l = Sorok * Oszlopok
Dim Szamok(1 To 500) As Integer    'Tmb ltrehozsa statikus
For i = 1 To Sorok * Oszlopok
If Mezok(i) Is Nothing Then
     Set Mezok(i) = New MezoInfo
     End If
    Szamok(i) = i
    Mezok(i).Init
Next i

For i = 0 To AknaSzam - 1
Gen:
  ind = Int(Rnd * (Sorok * Oszlopok - i)) + 1
  If ind = FirstOpen Then
  GoTo Gen
  End If
  Mezok(ind).Aknas = True
  Next i
  Generalva = True
  
  For i = 1 To Sorok * Oszlopok
    CountAdjMines (i)
    If Mezok(i).Aknas Then
        End If
    
    
  Next i
End Sub

Private Sub Form_Load()
Generalva = False
Leteve = False
PrevSize = 0
Randomize
End Sub


'Mezre kattints
Private Sub OpenField(Index As Integer, Optional openflagged As Boolean = True)

If Not openflagged And Mezok(Index).Flagged Then   'Ha jellve van nem nyitunk

Else


If Not Mezok(Index).Nyitott Then      'Csak akkor nyitunk ha mg nincs nyitva
    Mezok(Index).Nyitott = True
    If Mezok(Index).Aknas Then
        EndGame False
        MsgBox "Sajnos vesztettl!", vbOKOnly, "Vge a jtknak"
    Else
        Opened = Opened + 1
        szom = Mezok(Index).Szomszedos
        If szom = 0 Then        'A 0 mezk szomszdait is ki kell nyitni
            Button(Index).Enabled = False
            Button(Index).BackColor = &H80000016
            If Mezok(Index).Flagged Then
                FlagField (Index)
            End If

            OpenNeighbours (Index)
        Else
        Button(Index).Caption = Mezok(Index).Szomszedos
        If Opened = Sorok * Oszlopok - AknaSzam Then    'Ha minden res mezt kinyitottunk, akkor nyertnk
            EndGame True
            MsgBox "Gratullok, nyertl!", vbOKOnly, "Gyzelem!"
        End If
            
        End If
    End If
End If
End If


End Sub


'Szomszdos mezkn lev bombk szma
Private Sub CountAdjMines(ind As Integer)
 i = ind - 1
 If i \ Oszlopok > 0 Then
    Mezok(ind).Szomszedos = Mezok(ind).Szomszedos - Mezok(ind - Oszlopok).Aknas
 End If
  If i \ Oszlopok > 0 And i Mod Oszlopok > 0 Then
    Mezok(ind).Szomszedos = Mezok(ind).Szomszedos - Mezok(ind - Oszlopok - 1).Aknas
 End If
  If i \ Oszlopok > 0 And i Mod Oszlopok < Sorok - 1 Then
    Mezok(ind).Szomszedos = Mezok(ind).Szomszedos - Mezok(ind - Oszlopok + 1).Aknas
 End If
  If i \ Oszlopok < Sorok - 1 Then
    Mezok(ind).Szomszedos = Mezok(ind).Szomszedos - Mezok(ind + Oszlopok).Aknas
 End If
  If i \ Oszlopok < Sorok - 1 And i Mod Oszlopok > 0 Then
    Mezok(ind).Szomszedos = Mezok(ind).Szomszedos - Mezok(ind + Oszlopok - 1).Aknas
 End If
  If i \ Oszlopok < Sorok - 1 And i Mod Oszlopok < Sorok - 1 Then
    Mezok(ind).Szomszedos = Mezok(ind).Szomszedos - Mezok(ind + Oszlopok + 1).Aknas
 End If
  If i Mod Oszlopok > 0 Then
    Mezok(ind).Szomszedos = Mezok(ind).Szomszedos - Mezok(ind - 1).Aknas
 End If
  If i Mod Oszlopok < Sorok - 1 Then
    Mezok(ind).Szomszedos = Mezok(ind).Szomszedos - Mezok(ind + 1).Aknas
 End If
End Sub


'Megjelelt szomszdos mezk szma
Private Function CountAdjFlags(ind As Integer) As Integer
    flags = 0
     i = ind - 1
 If i \ Oszlopok > 0 Then
    flags = flags - Mezok(ind - Oszlopok).Flagged
 End If
  If i \ Oszlopok > 0 And i Mod Oszlopok > 0 Then
    flags = flags - Mezok(ind - Oszlopok - 1).Flagged
 End If
  If i \ Oszlopok > 0 And i Mod Oszlopok < Sorok - 1 Then
    flags = flags - Mezok(ind - Oszlopok + 1).Flagged
 End If
  If i \ Oszlopok < Sorok - 1 Then
    flags = flags - Mezok(ind + Oszlopok).Flagged
 End If
  If i \ Oszlopok < Sorok - 1 And i Mod Oszlopok > 0 Then
    flags = flags - Mezok(ind + Oszlopok - 1).Flagged
 End If
  If i \ Oszlopok < Sorok - 1 And i Mod Oszlopok < Sorok - 1 Then
    flags = flags - Mezok(ind + 11).Flagged
 End If
  If i Mod Oszlopok > 0 Then
    flags = flags - Mezok(ind - 1).Flagged
 End If
  If i Mod Oszlopok < Sorok - 1 Then
    flags = flags - Mezok(ind + 1).Flagged
 End If
 CountAdjFlags = flags
End Function


'Szomszdok kinyitsa
Private Sub OpenNeighbours(ind As Integer, Optional openflagged As Boolean = True)
 i = ind - 1
 If i \ Oszlopok > 0 Then
    OpenField (ind - Oszlopok), openflagged
 End If
  If i \ Oszlopok > 0 And i Mod Oszlopok > 0 Then
    OpenField (ind - Oszlopok - 1), openflagged
 End If
  If i \ Oszlopok > 0 And i Mod Oszlopok < Sorok - 1 Then
    OpenField (ind - Oszlopok + 1), openflagged
 End If
  If i \ Oszlopok < Sorok - 1 Then
    OpenField (ind + Oszlopok), openflagged
 End If
  If i \ Oszlopok < Sorok - 1 And i Mod Oszlopok > 0 Then
    OpenField (ind + Oszlopok - 1), openflagged
 End If
  If i \ Oszlopok < Sorok - 1 And i Mod Oszlopok < Sorok - 1 Then
    OpenField (ind + Oszlopok + 1), openflagged
 End If
  If i Mod Oszlopok > 0 Then
    OpenField (ind - 1), openflagged
 End If
  If i Mod Oszlopok < Sorok - 1 Then
    OpenField (ind + 1), openflagged
    End If
End Sub


'Jtk vgeztvel tiltjuk a gombokat
Private Sub EndGame(win As Boolean)
    If win Then
        For i = 1 To Sorok * Oszlopok
            Button(i).Enabled = False
            If Not Mezok(i).Flagged And Mezok(i).Aknas Then
                Button(i).Caption = "X"
            End If
        Next i

    
    Else
        For i = 1 To Sorok * Oszlopok
            Button(i).Enabled = False
            If Not Mezok(i).Flagged And Mezok(i).Aknas Then
                Button(i).Caption = "X"
            ElseIf Mezok(i).Flagged And Not Mezok(i).Aknas Then
                Button(i).BackColor = vbBlack
            End If
        Next i
    End If
End Sub
